﻿using System;
using GameEditor.Client.Data.DataServices;
using GameEditor.Client.Data.EventArgs;
using GameEditor.Common;
using GameEditor.Common.Interfaces;

namespace GameEditor.Client.Data
{
  public interface IGameModel : IModel
  {
    void LoadGamesAsync();
    void LoadGamesByGenreAsync(string genre);
    event EventHandler<LoadEntityCompleteEventArgs<Game>> LoadGamesComplete;

    void LoadGenresAsync();
    event EventHandler<LoadEntityCompleteEventArgs<Genre>> LoadGenresComplete;

    void LoadRatingsAsync();
    event EventHandler<LoadEntityCompleteEventArgs<Rating>> LoadRatingsComplete;

    void SaveAsync();
    event EventHandler<ErrorEventArgs> SaveComplete;
  }

  

}
