﻿using GameEditor.GameDetails.ViewModels;
using GameEditor.GameDetails.Views;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Composite.Regions;
using Microsoft.Practices.Unity;

namespace GameEditor.GameDetails
{
  public class GameDetailsModule : IModule
  {
    IRegionManager regionManager = null;
    IUnityContainer theContainer = null;

    public GameDetailsModule(IUnityContainer container, IRegionManager mgr)
    {
      regionManager = mgr;
      theContainer = container;
    }

    public void Initialize()
    {
      RegisterServices();

      // Get the Types
      var view = theContainer.Resolve<IGameDetailsView>();
      var vm = theContainer.Resolve<IGameDetailsViewModel>();

      // Add the Model
      view.ApplyModel(vm);

      regionManager.AddToRegion("DetailRegion", view);
    }

    void RegisterServices()
    {
      theContainer.RegisterType<IGameDetailsViewModel, GameDetailsViewModel>();
      theContainer.RegisterType<IGameDetailsView, GameDetailsView>();
    }
  }
}
