﻿using System.Windows;
using GameEditor.Client.Data;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Composite.UnityExtensions;
using Microsoft.Practices.Unity;

namespace GameEditor.GameDetailsHost
{
  public class MyBootstrapper : UnityBootstrapper
  {
    protected override void ConfigureContainer()
    {
      base.ConfigureContainer();
      this.Container.RegisterType<IGameModel, MockGameModel>(new ContainerControlledLifetimeManager());
    }

    protected override DependencyObject CreateShell()
    {
      Shell theShell = new Shell();
      App.Current.RootVisual = theShell;
      return theShell;
    }

    protected override IModuleCatalog GetModuleCatalog()
    {
      var details = new ModuleInfo("DetailModule", "GameEditor.GameDetails.GameDetailsModule, GameEditor.GameDetails, Version=1.0.0.0");
      details.Ref = "GameEditor.GameDetails.xap";

      var catalog = new ModuleCatalog().AddModule(details);
      return catalog;
    }
  }
}
