﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Practices.Composite.Modularity;
using Microsoft.Practices.Composite.Regions;
using GameEditor.GameList.Views;
using GameEditor.Client.Data;
using Microsoft.Practices.Unity;
using GameEditor.GameList.ViewModels;

namespace GameEditor.GameList
{
  public class GameListModule : IModule
  {
    IRegionManager regionManager = null;
    IUnityContainer container = null;
    public GameListModule(IUnityContainer con, IRegionManager mgr)
    {
      regionManager = mgr;
      container = con;
    }

    public void Initialize()
    {
      RegisterServices();

      // Build the View
      var view = container.Resolve<IGameListView>();

      // Get an Implemenation of IViewModel
      var viewModel = container.Resolve<IGameListViewModel>();

      // Marry Them
      view.ApplyModel(viewModel);

      // Show it in the region
      regionManager.AddToRegion("LookupRegion", view);
    }

    void RegisterServices()
    {
      container.RegisterType<IGameListView, GameListView>();
      container.RegisterType<IGameListViewModel, GameListViewModel>();
    }
  }
}
