﻿using System;
using System.Collections.Generic;
using System.Data.Services;
using System.Linq;
using System.ServiceModel.Web;
using System.Web;
using GameEditor.Data;
using System.Linq.Expressions;

namespace GameEditor.Web
{
  public class GameService : DataService<GameEntities>
  {
    public static void InitializeService(IDataServiceConfiguration config)
    {
      config.SetEntitySetAccessRule("Games", EntitySetRights.All);
      config.SetEntitySetAccessRule("Ratings", EntitySetRights.AllRead);
      config.SetEntitySetAccessRule("Genres", EntitySetRights.AllRead);

      // Enable full debug information 
      config.UseVerboseErrors = true;
    }

    [QueryInterceptor("Games")]
    public Expression<Func<Game, bool>> FilterGamesByMicrosoft()
    {
      // Only allow MS Published Games
      return g => g.Publisher.StartsWith("Microsoft") || 
                  g.Publisher.StartsWith("Bungie") ||
                  g.Publisher.StartsWith("Turn 10") ||
                  g.Publisher.StartsWith("XBox") ||
                  g.Publisher.StartsWith("Rare") ||
                  g.Publisher.StartsWith("Ensemble") ||
                  g.Publisher.StartsWith("Wingnut") ||
                  g.Publisher.StartsWith("Lionhead");
    }

  }
}
