﻿using System;
using System.Linq;
using System.Windows;
using Microsoft.Practices.Composite.Modularity;
using GameEditor.Common.Interfaces;
using System.Threading;
using System.Diagnostics;

namespace GameEditor
{
  public partial class App : Application
  {

    public App()
    {
      this.Startup += this.Application_Startup;
      this.Exit += this.Application_Exit;
      this.UnhandledException += this.Application_UnhandledException;

      InitializeComponent();
    }

    private void Application_Startup(object sender, StartupEventArgs e)
    {
      Bootstrapper boot = new Bootstrapper();
      boot.Run();
    }

    private void Application_Exit(object sender, EventArgs e)
    {

    }
    private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
    {
      e.Handled = true;
      string errorMsg = string.Concat("Error Occurred: ", Environment.NewLine, Environment.NewLine, e.ExceptionObject);
      MessageBox.Show(errorMsg, "Error Occurred", MessageBoxButton.OK);
    }

  }
}
