﻿using System.ServiceModel;
using Microsoft.Practices.Composite.Logging;
using ServerLogger.LoggingServices;

namespace ServerLogger
{
  public class ServerBasedLogger : ILoggerFacade
  {
    LoggingServiceClient client;

    public void Log(string message, Category category, Priority priority)
    {
      try
      {
        TheClient.LogAsync(string.Format("Logging: Category: {0} - Priority: {1}: {2}", category, priority, message));
      }
      catch
      {
        // If fails, do nothing as a bad logger
        // shouldn't bring the app down
      }
    }

    LoggingServiceClient TheClient
    {
      get
      {
        if (client == null)
        {
          BasicHttpBinding bind = new BasicHttpBinding();
          EndpointAddress addr = new EndpointAddress("http://localhost:8000/LoggingService.svc");
          client = new LoggingServiceClient(bind, addr);
        }
        return client;
      }
    }


  }
}
