﻿Imports System.ComponentModel

Namespace DataServices
  Partial Public Class GameEntities

    Private Sub OnContextCreated()
      ' Force all game queries to include the Genres and Ratings
      _Games = MyBase.CreateQuery(Of Game)("Games").Expand("Genre").Expand("Rating")
    End Sub

  End Class

  Partial Public Class Game
      Implements INotifyPropertyChanged

    Private Sub OnDescriptionChanged()
      FirePropertyChanged("Description")
    End Sub

    Private Sub OnDeveloperChanged()
        FirePropertyChanged("Developer")
    End Sub

    Private Sub OnGameIDChanged()
        FirePropertyChanged("GameID")
    End Sub

    Private Sub OnImageUrlChanged()
        FirePropertyChanged("ImageUrl")
    End Sub

    Private Sub OnNameChanged()
        FirePropertyChanged("Name")
    End Sub

    Private Sub OnPriceChanged()
        FirePropertyChanged("Price")
    End Sub

    Private Sub OnPublisherChanged()
        FirePropertyChanged("Publisher")
    End Sub

    Private Sub OnReleaseDateChanged()
        FirePropertyChanged("ReleaseDate")
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub FirePropertyChanged(ByVal [property] As String)
      RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs([property]))
    End Sub


    Public Function IsValid() As Boolean
      Return CType((Name.Length > 4 And Price > 0), Boolean)
    End Function

  End Class

  Partial Public Class Genre
      Implements INotifyPropertyChanged
    Private Sub OnGenreIDChanged()
        FirePropertyChanged("GenreID")
    End Sub
    Private Sub OnNameChanged()
        FirePropertyChanged("Name")
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub FirePropertyChanged(ByVal [property] As String)
      RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs([property]))
    End Sub
  End Class

  Partial Public Class Rating
      Implements INotifyPropertyChanged
    Private Sub OnRatingIDChanged()
        FirePropertyChanged("RatingID")
    End Sub
    Private Sub OnNameChanged()
        FirePropertyChanged("Name")
    End Sub
    Private Sub OnUrlChanged()
        FirePropertyChanged("Url")
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub FirePropertyChanged(ByVal propertyName As String)
      RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub
  End Class
End Namespace