﻿Imports GameEditor.GameDetails.ViewModels
Imports GameEditor.GameDetails.Views
Imports Microsoft.Practices.Composite.Modularity
Imports Microsoft.Practices.Composite.Regions
Imports Microsoft.Practices.Unity

Public Class GameDetailsModule
  Implements IModule
  Private regionManager As IRegionManager = Nothing
  Private theContainer As IUnityContainer = Nothing

  Public Sub New(ByVal container As IUnityContainer, ByVal mgr As IRegionManager)
    regionManager = mgr
    theContainer = container
  End Sub

  Public Sub Initialize() Implements IModule.Initialize
    RegisterServices()

    ' Get the Types
    Dim view = theContainer.Resolve(Of IGameDetailsView)()
    Dim vm = theContainer.Resolve(Of IGameDetailsViewModel)()

    ' Add the Model
    view.ApplyModel(vm)

    regionManager.AddToRegion("DetailRegion", view)
  End Sub

  Private Sub RegisterServices()
    theContainer.RegisterType(Of IGameDetailsViewModel, GameDetailsViewModel)()
    theContainer.RegisterType(Of IGameDetailsView, GameDetailsView)()
  End Sub
End Class
