Imports Microsoft.VisualBasic
Imports System
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Practices.Composite.Modularity
Imports Microsoft.Practices.Composite.Regions
Imports GameEditor.GameList.Views
Imports GameEditor.Client.Data
Imports Microsoft.Practices.Unity
Imports GameEditor.GameList.ViewModels

Public Class GameListModule
  Implements IModule

  Private regionManager As IRegionManager = Nothing
  Private container As IUnityContainer = Nothing

  Public Sub New(ByVal con As IUnityContainer, ByVal mgr As IRegionManager)
    regionManager = mgr
    container = con
  End Sub

  Public Sub Initialize() Implements IModule.Initialize
    RegisterServices()

    ' Build the View
    Dim view = container.Resolve(Of IGameListView)()

    ' Get an Implemenation of IViewModel
    Dim viewModel = container.Resolve(Of IGameListViewModel)()

    ' Marry Them
    view.ApplyModel(viewModel)

    ' Show it in the region
    regionManager.AddToRegion("LookupRegion", view)
  End Sub

  Private Sub RegisterServices()
    container.RegisterType(Of IGameListView, GameListView)()
    container.RegisterType(Of IGameListViewModel, GameListViewModel)()
  End Sub

End Class
