﻿Imports System.Data.Services
Imports System.Linq
Imports System.ServiceModel.Web
Imports GameEditor.Data
Imports System.Linq.Expressions

Public Class GameService
  Inherits DataService(Of GameEntities)
  Public Shared Sub InitializeService(ByVal config As IDataServiceConfiguration)
    config.SetEntitySetAccessRule("Games", EntitySetRights.All)
    config.SetEntitySetAccessRule("Ratings", EntitySetRights.AllRead)
    config.SetEntitySetAccessRule("Genres", EntitySetRights.AllRead)

    ' Enable full debug information 
    config.UseVerboseErrors = True
  End Sub

  <QueryInterceptor("Games")> _
  Public Function FilterGamesByMicrosoft() As Expression(Of Func(Of Game, Boolean))
    ' Only allow MS Published Games
    Return Function(g) g.Publisher.StartsWith("Microsoft") OrElse _
                       g.Publisher.StartsWith("Bungie") OrElse _
                       g.Publisher.StartsWith("Turn 10") OrElse _
                       g.Publisher.StartsWith("XBox") OrElse _
                       g.Publisher.StartsWith("Rare") OrElse _
                       g.Publisher.StartsWith("Ensemble") OrElse _
                       g.Publisher.StartsWith("Wingnut") OrElse _
                       g.Publisher.StartsWith("Lionhead")
  End Function

End Class