﻿Imports GameEditor.Common.Interfaces
Imports Microsoft.Practices.Composite.Modularity
Imports Microsoft.Practices.Composite.UnityExtensions

Public Class Bootstrapper
  Inherits UnityBootstrapper

  Protected Overrides Sub ConfigureContainer()
    Container.RegisterType(Of IShellProvider, Shell)()
    MyBase.ConfigureContainer()
  End Sub

  Protected Overrides Function CreateShell() As DependencyObject
    Dim shell As IShellProvider = Container.Resolve(Of IShellProvider)()
    App.Current.RootVisual = shell.CreateShell()
    Return App.Current.RootVisual
  End Function

  Protected Overrides Function GetModuleCatalog() As IModuleCatalog
    Dim catalog = ModuleCatalog.CreateFromXaml(New Uri("catalog.xaml", UriKind.Relative))
    Return catalog
  End Function
End Class
