﻿Imports System.ServiceModel
Imports Microsoft.Practices.Composite.Logging
Imports ServerLogger.LoggingServices

Public Class ServerBasedLogger
  Implements ILoggerFacade
  Private client As LoggingServiceClient

  Public Sub Log(ByVal message As String, ByVal category As Category, _
                 ByVal priority As Priority) _
    Implements ILoggerFacade.Log

    Try
      TheClient.LogAsync(String.Format("Logging: Category: {0} - Priority: {1}: {2}", category, priority, message))
    Catch
      ' If fails, do nothing as a bad logger
      ' shouldn't bring the app down
    End Try

  End Sub

  Private ReadOnly Property TheClient() As LoggingServiceClient
    Get
      If client Is Nothing Then
        Dim bind As New BasicHttpBinding()
        Dim addr As New EndpointAddress("http://localhost:8000/LoggingService.svc")
        client = New LoggingServiceClient(bind, addr)
      End If
      Return client
    End Get
  End Property


End Class
